/* 8bit u-law / 8kHz  data ñ˷Ҥ
 * shige
 * 02/16 1999 ver 0.1
 * 03/09 1999 ver 0.2
 * 05/02 2000 ver 0.3
 * auconn.c
 *
 * $Id: auconn.c,v 1.5 2000-10-01 21:13:15+09 shige Exp $
 */
/* 02/16 1999
 * 1)	椯椯ϿʤΤĤʤѤˤ
 * 03/09 1999
 * 2)	file  full path ͿƤȤ shell  command line 
 * 	buffer θ³롣äơsearch path ꤹ褦ˤ롣
 * 	ϡ file  path Ǥʤdata format ʤɿ 
 *	command line opetion 񤱤褦ˤ롣ޤǳĥ
 *	ʤ
 * 05/02 2000
 * 3)	strtok  csrc/test/teststrt.c ˤ⤢褦ˡconstant ʸ
 *	ФƤ Bus error
 */
#ifndef __AUCONN_C__
#define __AUCONN_C__

#include "auconn.h"

/* ########## main routine ########## */
int main(int argc,char *argv[],char *env[])
{
    int j,j0,k,N,inoption;
    char c,*conffname=NULL;
    Snddata snddata[Maxdatanum];

    if(argc<2){ usage(); return Exit_noarg; }
    inithome(env);
    j=1;
    if(*argv[j]=='-'){
	c=*(++argv[j]);
	while(1){
	    switch(c){
	    case 'p':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(addstr2pathlist(argv[j])<0){
		    usage();
		    return Exit_addstr2pathlist;
		}
		inoption=0;
		break;
	    case 'e':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(addstr2extlist(argv[j])<0){
		    usage();
		    return Exit_addstr2extlist;
		}
		inoption=0;
		break;
	    case 'f':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		conffname=argv[j];
		if(addfile2list(argv[j])<0){
		    usage();
		    return Exit_addfile2list;
		}
		inoption=0;
		break;
	    case 'q':
		verbose=0;
		inoption=1;
		break;
	    case 'l':
		listonly=1;
		inoption=1;
		break;
	    default:
		usage(); return Exit_unknownarg;
	    }
	    if(inoption && (c=*(++argv[j]))!='\0') continue;
	    if(++j>=argc){ usage(); return Exit_noarg; }
	    if(*argv[j]!='-') break;
	    c=*(++argv[j]);
	}
    }
    if(initpathextlist(env)<0){
	usage();
	return Exit_envdefault;
    }
    /* j  argc-1  au file ̾
     * option ˤäƤ file ̾ stdin 餦äƤΤ⤤⤷
     * ʤ
     */
#ifdef DEBUG4
    putallpathlist();
    putallextlist();
#endif
    if(listonly){
	for(k=j;k<argc;k++)
	  if((tmpfile1=fopenpathlist(argv[k],tmpfile1))!=NULL){
	      fclose(tmpfile1); tmpfile1=NULL;
	  }
	return No_err;
    }
    j0=j;
    if(argc-1-j0+1>Maxdatanum){ usage(); return Exit_toomanyarg; }
    N=argc-1-j0+1;
    /* 1 ܤ file 򳫤 */
    if((tmpfile1=fopenpathlist(argv[j0],tmpfile1))==NULL)
      return Exit_openpathfile;
    if(getSndheader(tmpfile1,&snddata[0])<0) return Exit_getSndheader;
    /* 2 ܰʹߤ file 򳫤 header  1 ܤΤΤ */
    for(j=2;j<=N;j++){
	if((tmpfile1=fopenpathlist(argv[j0+j-1],tmpfile1))==NULL) 
	  return Exit_openpathfile;
	if(getSndheader(tmpfile1,&snddata[j-1])<0) return Exit_getSndheader;
	if(chSndheader(&snddata[j-1],&snddata[0])<0) return Exit_chSndheader;
    }
    /*  */
    putallheader(stdout,snddata,N);
    for(j=1;j<=N;j++){
	if((tmpfile1=fopenpathlist(argv[j0+j-1],tmpfile1))==NULL)
	  return Exit_openpathfile;
	putSnddata(tmpfile1,stdout,snddata[j-1].hlen,snddata[j-1].datalen);
	fclose(tmpfile1); tmpfile1=NULL;
    }
    return No_err;
}

/* ########## usage ########## */
void usage(void)
{
    char *mess[]={
	"Usage: auconn [options] [aufile] ([aufile] ...)",
	" options:",
	"   -p[path]: aufile ѥ",
	"             (default= " DEF_Pathlist ")",
	"   -e[ext] : aufile ĥ",
	"             (default= " DEF_Extlist ")",
	"   -f[file]: ե (default= " DEF_Conffname ")",
	"   -l      : au file ΥꥹȤΤɽ",
	"   -q      : 顼ɽʤ",
	" ",
	" [1] ѥĥҤϡ (':') ǥߥȤʣǤ롣",
	" [2] եˤϡǥեȤθѥĥҤǤ롣",
	"     եǤ '#' ǻϤޤԤϥȤȸʤ졢Ԥ",
	"     ̵뤵롣ԤΥեޥåȤ",
	"       [] [ꥹ]",
	"     Ǥꡢ[] ϸѥ \"path\", ĥҤ \"ext\" Ȥ롣",
	"     եǤ ':' ͭĹʤϡƱ",
	"     ʣιԤ񤱤Ф褤",
	" [3] ѥĥҤϡ줾Ķѿ " DEF_PathEnvname ", " DEF_ExtEnvname " ⻲Ȥ롣",
	"     ̤ͥ",
	"       ޥɥ饤 > Ķѿ > ե > ǥե",
	"     ν (ǥեȤϥѥΥǥեȤǡ", 
	"     ץβս default: Ȥƽ񤫤Ƥ)",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}

#endif /* __AUCONN_C__ */
