/* linear WAV  data ñ˷Ҥ
 * shige
 * 10/01 2000
 * wavconn.c
 *
 * $Id: wavconn.c,v 1.3 2000-10-01 21:13:43+09 shige Exp $
 */
#ifndef __WAVCONN_C__
#define __WAVCONN_C__

#include "wavconn.h"

/* ########## main routine ########## */
int main(int argc,char *argv[],char *env[])
{
    int j,j0,k,N,inoption;
    char c,*conffname=NULL;
    WAVdata wavdata[Maxdatanum];

    if(argc<2){ usage(); return Exit_noarg; }
    inithome(env);
    j=1;
    if(*argv[j]=='-'){
	c=*(++argv[j]);
	while(1){
	    switch(c){
	    case 'p':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(addstr2pathlist(argv[j])<0){
		    usage();
		    return Exit_addstr2pathlist;
		}
		inoption=0;
		break;
	    case 'e':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(addstr2extlist(argv[j])<0){
		    usage();
		    return Exit_addstr2extlist;
		}
		inoption=0;
		break;
	    case 'f':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		conffname=argv[j];
		if(addfile2list(argv[j])<0){
		    usage();
		    return Exit_addfile2list;
		}
		inoption=0;
		break;
	    case 'q':
		verbose=0;
		inoption=1;
		break;
	    case 'l':
		listonly=1;
		inoption=1;
		break;
	    default:
		usage(); return Exit_unknownarg;
	    }
	    if(inoption && (c=*(++argv[j]))!='\0') continue;
	    if(++j>=argc){ usage(); return Exit_noarg; }
	    if(*argv[j]!='-') break;
	    c=*(++argv[j]);
	}
    }
    if(initpathextlist(env)<0){
	usage();
	return Exit_envdefault;
    }
    if(listonly){
	for(k=j;k<argc;k++)
	  if((tmpfile1=fopenpathlist(argv[k],tmpfile1))!=NULL){
	      fclose(tmpfile1); tmpfile1=NULL;
	  }
	return No_err;
    }
    j0=j;
    if(argc-1-j0+1>Maxdatanum){ usage(); return Exit_toomanyarg; }
    N=argc-1-j0+1;
    /* 1 ܤ file 򳫤 */
    if((tmpfile1=fopenpathlist(argv[j0],tmpfile1))==NULL)
      return Exit_openpathfile;
    if(getWAVheader(tmpfile1,&wavdata[0])<0) return Exit_getWAVheader;
    if(wavdata[0].fmcode!=1) return Exit_unsupported_format;
    /* 2 ܰʹߤ file 򳫤 header  1 ܤΤΤ */
    for(j=2;j<=N;j++){
	if((tmpfile1=fopenpathlist(argv[j0+j-1],tmpfile1))==NULL) 
	  return Exit_openpathfile;
	if(getWAVheader(tmpfile1,&wavdata[j-1])<0) return Exit_getWAVheader;
	if(chWAVheader(&wavdata[j-1],&wavdata[0])<0) return Exit_chWAVheader;
    }
    /*  */
    putallWAVheader(stdout,wavdata,N);
    for(j=1;j<=N;j++){
	if((tmpfile1=fopenpathlist(argv[j0+j-1],tmpfile1))==NULL)
	  return Exit_openpathfile;
	putWAVdata(tmpfile1,stdout,wavdata[j-1].hlen,wavdata[j-1].datalen);
	fclose(tmpfile1); tmpfile1=NULL;
    }
    return No_err;
}

/* ########## usage ########## */
void usage(void)
{
    char *mess[]={
	"Usage: wavconn [options] [wavfile] ([wavfile] ...)",
	" options:",
	"   -p[path]: wavfile ѥ",
	"             (default= " DEF_Pathlist ")",
	"   -e[ext] : wavfile ĥ",
	"             (default= " DEF_Extlist ")",
	"   -f[file]: ե (default= " DEF_Conffname ")",
	"   -l      : wav file ΥꥹȤΤɽ",
	"   -q      : 顼ɽʤ",
	" ",
	" [1] ѥĥҤϡ (':') ǥߥȤʣǤ롣",
	" [2] եˤϡǥեȤθѥĥҤǤ롣",
	"     եǤ '#' ǻϤޤԤϥȤȸʤ졢Ԥ",
	"     ̵뤵롣ԤΥեޥåȤ",
	"       [] [ꥹ]",
	"     Ǥꡢ[] ϸѥ \"path\", ĥҤ \"ext\" Ȥ롣",
	"     եǤ ':' ͭĹʤϡƱ",
	"     ʣιԤ񤱤Ф褤",
	" [3] ѥĥҤϡ줾Ķѿ " DEF_PathEnvname ", " DEF_ExtEnvname " ⻲Ȥ롣",
	"     ̤ͥ",
	"       ޥɥ饤 > Ķѿ > ե > ǥե",
	"     ν (ǥեȤϥѥΥǥեȤǡ", 
	"     ץβս default: Ȥƽ񤫤Ƥ)",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}

#endif /* __WAVCONN_C__ */
